Np=2^5;             %points in the T interval
Il=2^12;            %information sequence length
EbN0dBv=5:0.5:10;   %Eb/N0 in dB;
p0=1/2;             %'0' probability
alfa=1;             %roll off factor
intervals=10;       %raised cosine intervals
raised_cosine=1;    %1 for raised cosine, manchester otw
                    %equalizer designed for raised cosine
useami=0;           %1 if AMI is used
Nr=10;              %number of simulations
                    %must be 1 for eye plot; 
                    %> 1 for power spectrum
fmax=Np/2;          
fn=1/2;             %normalized Nyquist frequency
zeri=[];
fp=fn/2;            %normalized channel pole (<= fn)
poli=[fp];
ideal_channel=0;    %1 for ideal channel
equa_rx=1;          %1 for equalization at receiver
plot_power_spectrum=0; 
                    %Nr>1 and length(EbN0dBv)=1 only
new_plot=0;
plot_color='r';
plot_eye=0;         %Nr=1 and length(EbN0dBv)=1 only
%end of data

if fp>fn
    disp('wrong pole');
    return;
end
if raised_cosine
    g=square_root_raised_cosine(alfa,Np,intervals);
else
    g=manchester(Np);
end

%channel and equalizer design
fpoints=length(g);
[channel, Channel, fgrafico]=zeripoli(fmax,zeri,poli,fpoints);
channel=real(channel);
zeri_equa=[fp];
poli_equa=[2*fn 2*fn 4*fn 4*fn];
[equa, Equa, fgrafico]=zeripoli(fmax,zeri_equa,poli_equa,fpoints);
equa=real(equa);

%determine the complete channel response

if ideal_channel==1
    gt=g;
    gr=fliplr(g);
else
    if equa_rx==1
        gt=conv(g,channel);
        gr=conv(fliplr(g),equa);
    else
        gt=conv(equa,conv(g,channel));
        gr=fliplr(g);
    end
end
response=conv(gt,gr); %risposta impulsiva
[mr,ir]=max(response);      %ir  la posizione del massimo

%simulation
bervh=[];bervs=[];
nsnrs=length(EbN0dBv);
for in=1:nsnrs    
    EbN0=10^(EbN0dBv(in)/10);
    if useami==1
        vn=(1-p0)/(2*EbN0);
    else
        vn=1/(2*EbN0);
    end
    ber=[];
    psm=[];
    for is=1:Nr
        x=zeros(Il,Np);
        info=rand(1,Il)>p0;
        if useami==1
            a=AMI(info);
        else
            a=2*info-1;
        end
        x(:,1)=a';
        x=reshape(x',1,Np*Il);
        st=conv(x,gt);
        noise=randn(1,length(st))*vn^0.5;
        sr=st+noise;
        r=conv(gr,sr);
        if Nr==1 && plot_eye && nsnrs==1
            figure
            for i=1:Il, plot(r(ir-Np/2+(i-1)*Np:ir-Np/2+i*Np),'r'); hold on; end
        end
        rv=r(ir:Np:ir+Np*(Il-1));
        if useami==1
            dech=abs(rv)>0.5;
            decs=vitdecode(rv,[1 2;2 1],[0 1;0 -1],Il,1,Il);
        else
            dech=rv>0;
        end
        errorsh=xor(dech,info);
        berh(is)=sum(errorsh)/Il;
        if useami==1
            errorss=xor(decs,info);
            bers(is)=sum(errorss)/Il;
        end
        psm(is,:)=(abs(fft(r))).^2;
    end
    bervh(in)=mean(berh)
    if useami==1
        bervs(in)=mean(bers)
    end
end

if (Nr>1)&&(plot_power_spectrum)&&(nsnrs==1)
    ps=mean(psm);
    warning off
    fx=0:Np/(length(ps)+1):Np/4;
    if new_plot
        h0=figure;
        h1 = axes('Parent',h0, ...
            'YLimMode','manual', ...
            'YLim',[-80, 0], ...
            'XLimMode','manual', ...
            'XLim',[0, fx(length(fx))]);

        hold
    else
        hold
    end
    fi=1:length(fx);
    plot(fx,10*log10(ps(fi)/max(ps)),plot_color)
    xlabel('fT');
    ylabel('power spectrum [dB]'); 
    warning on
    hold
end
